﻿package com.Tutorial
{
    import com.adamatomic.flixel.*;
    
    public class Player extends FlxSprite
    {
        [Embed(source = '../../data/gfx/player.png')] public static var ImgPlayer:Class;
        
        private var _move_speed:int = 2000;
        private var _jump_power:int = 800;   
        private var _max_health:int = 10;
		public var direction:int = 0;
		private var _moving:Boolean = false;
		private var _canmove:Boolean = true;
		private var _timer:Number;
		private var _lastTouch:Number=0;

        public function Player(X:Number,Y:Number,Dir:String):void
        {
            super(ImgPlayer, X, Y, true, true,6,11);//Max speeds
					
			_timer = 10;
            maxVelocity.x = 50;
            maxVelocity.y = 50;
            //Set the player health
            health = 10;
            //Gravity
            acceleration.y = 0;            
            //Friction
            drag.x = 800;
            drag.y = 800;
            //bounding box tweaks
            width = 6;
            height = 10;
            offset.x = 0;
            offset.y = 1;
			addAnimation("standing",[0]);
			addAnimation("walking",[0,1],3);
			addAnimation("touching",[2,3],8);
			
			play("standing");

			this.update();
        }
    
		public function stop():void
		{
			_canmove = false;
			play("standing");
			switch(direction)
			{
				case 0:
				this.specificFrame(0);
				this._curFrame = 0;
				break;
				case 1:
				this.specificFrame(1);
				this._curFrame = 0;
				break;
				case 2:
				this.specificFrame(3);
				this._curFrame = 0;
				break;
				case 3:
				this.specificFrame(2);
				this._curFrame = 0;
				break;
			}
			this.update();
		}
		
		public function start():void
		{
			_canmove = true;
		}
        override public function update():void
        {
            super.update();		

			if (_timer > 5 && _timer - FlxG.elapsed <= 5)
			{
				FlxG.quake(0.05, 0.1);
			}
			
			if (_timer > 3 && _timer - FlxG.elapsed <= 3)
			{
				FlxG.quake(0.05, 0.5);
			}
			
			if (_timer > 1 && _timer - FlxG.elapsed <= 1)
			{
				FlxG.quake(0.08, 2);
			}
			
			_timer -= FlxG.elapsed;
		
			if (_timer < 0)
			{
				this.x = 6 * 11;
				this.y = 7 * 11;
				_timer = 10;
			}
			
			var oldmoving:Boolean;
			oldmoving = _moving;
			var olddir:int;
			_moving = false;

			if (_lastTouch > 0)
			{
				_lastTouch -= FlxG.elapsed;
				if (_lastTouch <0)
				{
					FlxG.quake(0.003, 0.5);
					_lastTouch = 1;
					
				}
			}
			if (FlxG.kA || FlxG.kB)
			{
				if (this._curAnim.name != "touching")
				{
					_lastTouch = 0.001;
					this.play("touching");
				}
				_timer = 10;
				return;
			}
			else
			{
				_lastTouch = -1;
			}

			if (FlxG.kDown)
			{
				velocity.y += _move_speed * FlxG.elapsed;
				if (oldmoving && this._curAnim.name!="walking"&&!(FlxG.kLeft||FlxG.kRight))
					this.play("walking");
				_moving = true;
				direction = 1;
			}
            if(FlxG.kLeft)
            {
                velocity.x -= _move_speed * FlxG.elapsed;
				if (oldmoving && this._curAnim.name != "walking"&&!FlxG.kUp)
				{
					this.play("walking");
				}
				_moving = true;
				direction = 2;
				this.facing = true;				
            }
            if (FlxG.kRight)
            {
                velocity.x += _move_speed * FlxG.elapsed;  
				if (oldmoving && this._curAnim.name!="walking"&&!FlxG.kUp)
					this.play("walking");
				_moving = true;
				direction = 3;
				this.facing = false;

            }
			if (FlxG.kUp)
			{
				velocity.y -= _move_speed * FlxG.elapsed;
				if (oldmoving && this._curAnim.name!="walking")
					this.play("walking");
				_moving = true;
				direction = 0;
			}
			
			if (!_moving)
			{
				this.play("standing");
			}
			
			if (x < 8)
			{
				if (FlxG.level < 9)
				{
					FlxG.oldlevel = FlxG.level;
					FlxG.level=9
				}
				else
				{
					if (y < 3 * 16)
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 1;
					}
					else
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 7;
					}
				}		
//				WalkState.fromMenu = false;
//				FlxG.switchState(WalkState);		
			}
			else if (x > FlxG.width - 16- 8)
			{
				if (FlxG.level < 9)
				{
					FlxG.oldlevel = FlxG.level;
					FlxG.level=9
				}
				else
				{
					if (y < 3 * 16)
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 6;
					}
					else
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 0;
					}
				}			
//				WalkState.fromMenu = false;
//				FlxG.switchState(WalkState);	
			}
			else if (y < 8)
			{
				if (FlxG.level < 9)
				{
					FlxG.oldlevel = FlxG.level;
					FlxG.level=9
				}
				else
				{
					if (x < 3 * 16)
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 8;
					}
					else if (x < 5 * 16)
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 5;
					}
					else
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 3;
					}
				}			
//				WalkState.fromMenu = false;
//				FlxG.switchState(WalkState);	
			}
			else if (y > FlxG.height - 16 - 16 - 8)
			{
				if (FlxG.level < 9)
				{
					FlxG.oldlevel = FlxG.level;
					FlxG.level=9
				}
				else
				{
					if (x < 3 * 16)
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 4;
					}
					else
					{
						FlxG.oldlevel = FlxG.level;
						FlxG.level = 2;
					}
				}
//				WalkState.fromMenu = false;
//				FlxG.switchState(WalkState);				
			}
			
        }    
    }
}